Package com.io7m.jregions.core.parameterized.areas

# Class PAreaD.Builder<S>

java.lang.Object
com.io7m.jregions.core.parameterized.areas.PAreaD.Builder<S>

Enclosing class:
  PAreaD<S>

public static final class PAreaD.Builder<S> extends Object
Builds instances of type `PAreaD`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `PAreaD<S>`
  `build()`
  Builds a new `PAreaD`.
  `final PAreaD.Builder<S>`
  `from(PAreaDType<S> instance)`
  Fill a builder with attribute values from the provided `com.io7m.jregions.core.parameterized.areas.PAreaDType` instance.
  `final PAreaD.Builder<S>`
  `from(AreaValuesDType instance)`
  Fill a builder with attribute values from the provided `com.io7m.jregions.core.unparameterized.areas.AreaValuesDType` instance.
  `final PAreaD.Builder<S>`
  `setMaximumX(double maximumX)`
  Initializes the value for the `maximumX` attribute.
  `final PAreaD.Builder<S>`
  `setMaximumY(double maximumY)`
  Initializes the value for the `maximumY` attribute.
  `final PAreaD.Builder<S>`
  `setMinimumX(double minimumX)`
  Initializes the value for the `minimumX` attribute.
  `final PAreaD.Builder<S>`
  `setMinimumY(double minimumY)`
  Initializes the value for the `minimumY` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final PAreaD.Builder<S> from(PAreaDType<S> instance)
    Fill a builder with attribute values from the provided `com.io7m.jregions.core.parameterized.areas.PAreaDType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### from

    public final PAreaD.Builder<S> from(AreaValuesDType instance)
    Fill a builder with attribute values from the provided `com.io7m.jregions.core.unparameterized.areas.AreaValuesDType` instance.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinimumX

    public final PAreaD.Builder<S> setMinimumX(double minimumX)
    Initializes the value for the `minimumX` attribute.
    Parameters:
      `minimumX` - The value for minimumX
    Returns:
      `this` builder for use in a chained invocation

  - ### setMaximumX

    public final PAreaD.Builder<S> setMaximumX(double maximumX)
    Initializes the value for the `maximumX` attribute.
    Parameters:
      `maximumX` - The value for maximumX
    Returns:
      `this` builder for use in a chained invocation

  - ### setMinimumY

    public final PAreaD.Builder<S> setMinimumY(double minimumY)
    Initializes the value for the `minimumY` attribute.
    Parameters:
      `minimumY` - The value for minimumY
    Returns:
      `this` builder for use in a chained invocation

  - ### setMaximumY

    public final PAreaD.Builder<S> setMaximumY(double maximumY)
    Initializes the value for the `maximumY` attribute.
    Parameters:
      `maximumY` - The value for maximumY
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public PAreaD<S> build()
    Builds a new `PAreaD`.
    Returns:
      An immutable instance of PAreaD
    Throws:
      `IllegalStateException` - if any required attributes are missing